const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const reactions = sequelize.define(
    'reactions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

target_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"post",


"comment",


"story"

        ],

      },

reaction_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"like",


"love",


"haha",


"wow",


"sad",


"angry"

        ],

      },

reacted_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  reactions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.reactions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.reactions.belongsTo(db.posts, {
      as: 'post',
      foreignKey: {
        name: 'postId',
      },
      constraints: false,
    });

    db.reactions.belongsTo(db.comments, {
      as: 'comment',
      foreignKey: {
        name: 'commentId',
      },
      constraints: false,
    });

    db.reactions.belongsTo(db.stories, {
      as: 'story',
      foreignKey: {
        name: 'storyId',
      },
      constraints: false,
    });




    db.reactions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.reactions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return reactions;
};


